image: docker

services:
  - docker:dind

stages:
  - build
  - deploy

variables:
  DOCKER_DRIVER: overlay2
  GCP_REGISTRY_IMAGE: ${GCP_CONTAINER_REGISTRY}/${GCP_PROJECT_ID}/ffnet-to-kindle

build:
  stage: build
  tags: [docker]
  only:
    refs: [tags]
  before_script:
    - docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}
    - echo ${GCP_CERTIFICATE} | docker login -u _json_key --password-stdin https://${GCP_CONTAINER_REGISTRY}
  script:
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG} -t ${GCP_REGISTRY_IMAGE}:${CI_COMMIT_TAG} .
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
    - docker push ${GCP_REGISTRY_IMAGE}:${CI_COMMIT_TAG}

deploy:
  stage: deploy
  image: registry.gitlab.com/dkx/docker/gcloud:252.0.0
  tags: [docker]
  variables:
    GIT_STRATEGY: none
  only:
    refs: [tags]
  script:
    - gcloud beta run deploy ffnet-to-kindle
      --project=${GCP_PROJECT_ID}
      --image=${GCP_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
      --platform=managed
      --allow-unauthenticated
      --concurrency=80
      --memory=256Mi
      --timeout=300
      --region=us-central1
      --set-env-vars=SMTP_HOST=${SMTP_HOST},SMTP_PORT=${SMTP_PORT},SMTP_USER=${SMTP_USER},SMTP_PASSWORD=${SMTP_PASSWORD},SMTP_FROM=${SMTP_FROM}
